## kraken2 2.0.8~beta

=== src/Makefile ===
CXX = g++
CXXFLAGS = -fopenmp -Wall -std=c++11 -O3
CXXFLAGS += -DLINEAR_PROBING

.PHONY: all clean install

PROGS = estimate_capacity build_db classify dump_table lookup_accession_numbers

all: $(PROGS)

install: $(PROGS)
	cp $(PROGS) $(KRAKEN2_DIR)/

clean:
	rm -f *.o $(PROGS)

taxonomy.o: taxonomy.cc taxonomy.h mmap_file.h
mmap_file.o: mmap_file.cc mmap_file.h
compact_hash.o: compact_hash.cc compact_hash.h kv_store.h mmap_file.h
mmscanner.o: mmscanner.cc mmscanner.h
seqreader.o: seqreader.cc seqreader.h
omp_hack.o: omp_hack.cc omp_hack.h
reports.o: reports.cc reports.h
aa_translate.o: aa_translate.cc aa_translate.h
utilities.o: utilities.cc utilities.h

build_db: build_db.cc mmap_file.o compact_hash.o taxonomy.o seqreader.o mmscanner.o omp_hack.o utilities.o

classify: classify.cc reports.o mmap_file.o compact_hash.o taxonomy.o seqreader.o mmscanner.o omp_hack.o aa_translate.o utilities.o

estimate_capacity: estimate_capacity.cc seqreader.o mmscanner.o omp_hack.o utilities.o

dump_table: dump_table.cc mmap_file.o compact_hash.o omp_hack.o taxonomy.o reports.o

lookup_accession_numbers: lookup_accession_numbers.cc mmap_file.o omp_hack.o utilities.o

=== debian/changelog ===
kraken2 (2.0.8~beta-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:45:06 +0100

kraken2 (2.0.8~beta-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.0

 -- Andreas Tille <tille@debian.org>  Thu, 01 Aug 2019 13:36:17 +0200

kraken2 (2.0.7~beta-1) unstable; urgency=low

  * Initial release (Closes: #924567)

 -- Andreas Tille <tille@debian.org>  Thu, 14 Mar 2019 14:13:17 +0100

=== debian/control ===
Source: kraken2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12)
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/med-team/kraken2
Vcs-Git: https://salsa.debian.org/med-team/kraken2.git
Homepage: https://www.ccb.jhu.edu/software/kraken2/

Package: kraken2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ncbi-blast+
Description: taxonomic classification system using exact k-mer matches
 Kraken 2 is the newest version of Kraken, a taxonomic classification
 system using exact k-mer matches to achieve high accuracy and fast
 classification speeds. This classifier matches each k-mer within a query
 sequence to the lowest common ancestor (LCA) of all genomes containing
 the given k-mer. The k-mer assignments inform the classification
 algorithm. [see: Kraken 1's Webpage for more details].
 .
 Kraken 2 provides significant improvements to Kraken 1, with faster
 database build times, smaller database sizes, and faster classification
 speeds. These improvements were achieved by the following updates to the
 Kraken classification program:
 .
  1. Storage of Minimizers: Instead of storing/querying entire k-mers,
     Kraken 2 stores minimizers (l-mers) of each k-mer. The length of
     each l-mer must be ≤ the k-mer length. Each k-mer is treated by
     Kraken 2 as if its LCA is the same as its minimizer's LCA.
  2. Introduction of Spaced Seeds: Kraken 2 also uses spaced seeds to
     store and query minimizers to improve classification accuracy.
  3. Database Structure: While Kraken 1 saved an indexed and sorted list
     of k-mer/LCA pairs, Kraken 2 uses a compact hash table. This hash
     table is a probabilistic data structure that allows for faster
     queries and lower memory requirements. However, this data structure
     does have a <1% chance of returning the incorrect LCA or returning
     an LCA for a non-inserted minimizer. Users can compensate for this
     possibility by using Kraken's confidence scoring thresholds.
  4. Protein Databases: Kraken 2 allows for databases built from amino
     acid sequences. When queried, Kraken 2 performs a six-frame
     translated search of the query sequences against the database.
  5. 16S Databases: Kraken 2 also provides support for databases not
     based on NCBI's taxonomy. Currently, these include the 16S
     databases: Greengenes, SILVA, and RDP.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export KRAKEN2_DIR=$(CURDIR)/debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)

%:
	dh $@  --sourcedirectory=src

override_dh_link:
	dh_link
	for file in $(KRAKEN2_DIR)/kraken* ; do \
	    if ! echo $${file} | grep -q '\.pm$$' ; then \
		ln -s ../lib/$(DEB_SOURCE)/`basename $${file}` $(CURDIR)/debian/$(DEB_SOURCE)/usr/bin/`basename $${file}` ; \
	    fi \
	done

override_dh_auto_install:
	dh_auto_install -- KRAKEN2_DIR=$(KRAKEN2_DIR)
	./install_kraken2.sh $(KRAKEN2_DIR)

override_dh_install:
	dh_install
	for pl in `grep -Rl '#![[:space:]]*/usr/bin/env[[:space:]]\+perl' debian/*/usr/*` ; do \
	    sed -i '1s?^#![[:space:]]*/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
	done

=== debian/watch ===
version=4

opts="uversionmangle=s/-beta/~beta/" \
  https://github.com/DerrickWood/kraken2/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@

## kraken2 2.1.1

=== docs/Makefile ===
all:
	pandoc --title-prefix "Kraken 2 Manual" \
	       --include-in-header head.html \
	       --include-before-body top.html \
	       --from markdown --to html \
	       --table-of-contents \
	       --css kraken.css \
	       --output MANUAL.html \
	       < MANUAL.markdown

=== src/CMakeLists.txt ===
add_executable(build_db
        build_db.cc
        mmap_file.cc
        compact_hash.cc
        taxonomy.cc
        seqreader.cc
        mmscanner.cc
        omp_hack.cc
        utilities.cc)

add_executable(classify
        classify.cc
        reports.cc
        mmap_file.cc
        compact_hash.cc
        taxonomy.cc
        seqreader.cc
        mmscanner.cc
        omp_hack.cc
        aa_translate.cc
        utilities.cc)

add_executable(estimate_capacity
        estimate_capacity.cc
        seqreader.cc
        mmscanner.cc
        omp_hack.cc
        utilities.cc)

add_executable(dump_table
        dump_table.cc
        mmap_file.cc
        compact_hash.cc
        omp_hack.cc
        taxonomy.cc
        reports.cc)

add_executable(lookup_accession_numbers
        lookup_accession_numbers.cc
        mmap_file.cc
        omp_hack.cc
        utilities.cc)

=== src/Makefile ===
CXX = g++
CXXFLAGS = -fopenmp -Wall -std=c++11 -O3
CXXFLAGS += -DLINEAR_PROBING

.PHONY: all clean install

PROGS = estimate_capacity build_db classify dump_table lookup_accession_numbers

all: $(PROGS)

install: $(PROGS)
	cp $(PROGS) $(KRAKEN2_DIR)/

clean:
	rm -f *.o $(PROGS)

taxonomy.o: taxonomy.cc taxonomy.h mmap_file.h
hyperloglogplus.o: hyperloglogplus.cc hyperloglogplus.h
mmap_file.o: mmap_file.cc mmap_file.h
compact_hash.o: compact_hash.cc compact_hash.h kv_store.h mmap_file.h kraken2_data.h
mmscanner.o: mmscanner.cc mmscanner.h
seqreader.o: seqreader.cc seqreader.h
omp_hack.o: omp_hack.cc omp_hack.h
reports.o: reports.cc reports.h kraken2_data.h
aa_translate.o: aa_translate.cc aa_translate.h
utilities.o: utilities.cc utilities.h

classify.o: classify.cc kraken2_data.h kv_store.h taxonomy.h seqreader.h mmscanner.h compact_hash.h aa_translate.h reports.h utilities.h readcounts.h
dump_table.o: dump_table.cc compact_hash.h taxonomy.h mmscanner.h kraken2_data.h reports.h
estimate_capacity.o: estimate_capacity.cc kv_store.h mmscanner.h seqreader.h utilities.h
build_db.o: build_db.cc taxonomy.h mmscanner.h seqreader.h compact_hash.h kv_store.h kraken2_data.h utilities.h
lookup_accession_numbers.o: lookup_accession_numbers.cc mmap_file.h utilities.h

build_db: build_db.o mmap_file.o compact_hash.o taxonomy.o seqreader.o mmscanner.o omp_hack.o utilities.o
	$(CXX) $(CXXFLAGS) -o $@ $^

classify: classify.o reports.o hyperloglogplus.o mmap_file.o compact_hash.o taxonomy.o seqreader.o mmscanner.o omp_hack.o aa_translate.o utilities.o
	$(CXX) $(CXXFLAGS) -o $@ $^

estimate_capacity: estimate_capacity.o seqreader.o mmscanner.o omp_hack.o utilities.o
	$(CXX) $(CXXFLAGS) -o $@ $^

dump_table: dump_table.o mmap_file.o compact_hash.o omp_hack.o taxonomy.o reports.o hyperloglogplus.o
	$(CXX) $(CXXFLAGS) -o $@ $^

lookup_accession_numbers: lookup_accession_numbers.o mmap_file.o omp_hack.o utilities.o
	$(CXX) $(CXXFLAGS) -o $@ $^

=== debian/changelog ===
kraken2 (2.1.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 12 Nov 2020 23:26:29 +0530

kraken2 (2.1.0-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Wed, 14 Oct 2020 16:46:47 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12)
-Standards-Version: 4.4.0
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/kraken2
 Vcs-Git: https://salsa.debian.org/med-team/kraken2.git
 Homepage: https://www.ccb.jhu.edu/software/kraken2/
+Rules-Requires-Root: no
 
 Package: kraken2
 Architecture: any

## kraken2 2.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(kraken2)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_compile_options(-Wall)
add_definitions(-DLINEAR_PROBING)

set(CMAKE_CXX_FLAGS_DEBUG "-g")
set(CMAKE_CXX_FLAGS_RELEASE "-O3")

include(FindOpenMP)
if(OPENMP_FOUND)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
else(OPENMP_FOUND)
    message("ERROR: OpenMP could not be found.")
endif(OPENMP_FOUND)

add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,8 @@
         mmscanner.cc
         omp_hack.cc
         aa_translate.cc
-        utilities.cc)
+        utilities.cc
+        hyperloglogplus.cc)
 
 add_executable(estimate_capacity
         estimate_capacity.cc
@@ -33,7 +34,8 @@
         compact_hash.cc
         omp_hack.cc
         taxonomy.cc
-        reports.cc)
+        reports.cc
+        hyperloglogplus.cc)
 
 add_executable(lookup_accession_numbers
         lookup_accession_numbers.cc

=== src/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 all: $(PROGS)
 
 install: $(PROGS)
-	cp $(PROGS) $(KRAKEN2_DIR)/
+	cp $(PROGS) "$(KRAKEN2_DIR)/"
 
 clean:
 	rm -f *.o $(PROGS)

=== debian/changelog ===
kraken2 (2.1.2-1) unstable; urgency=medium

  * Team Upload.
  * d/watch: Fix watch regex
  * New upstream version 2.1.2
  * d/p/hardening+debug_options.patch: Propagate more hardening flags
  * Declare compliance with policy 4.5.1

 -- Nilesh Patra <nilesh@debian.org>  Sun, 15 Aug 2021 18:51:26 +0530

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/kraken2
 Vcs-Git: https://salsa.debian.org/med-team/kraken2.git
 Homepage: https://www.ccb.jhu.edu/software/kraken2/

=== debian/watch ===
version=4

opts="uversionmangle=s/-beta/~beta/" \
  https://github.com/DerrickWood/kraken2/releases .*/archive/.*/v?@ANY_VERSION@@ARCHIVE_EXT@

## kraken2 2.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,4 +23,8 @@
     message("ERROR: OpenMP could not be found.")
 endif(OPENMP_FOUND)
 
+find_package(Threads REQUIRED)
+find_package(ZLIB REQUIRED)
+include_directories(${ZLIB_INCLUDE_DIRS})
+
 add_subdirectory(src)

=== docs/Makefile ===
all:
	pandoc -s \
	       -V "pagetitle:Kraken 2 Manual" \
	       --include-in-header head.html \
	       --include-before-body top.html \
	       --from markdown --to html \
	       --table-of-contents \
	       --css kraken.css \
	       --output MANUAL.html \
	       < MANUAL.markdown

#-V "pagetitle:Kraken 2 Manual" \

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -42,3 +42,9 @@
         mmap_file.cc
         omp_hack.cc
         utilities.cc)
+
+add_executable(k2mask
+        k2mask.cc
+        seqreader.cc)
+
+target_link_libraries(dustmasker ${ZLIB_LIBRARIES} Threads::Threads)

=== src/Makefile ===
--- 
+++ 
@@ -1,10 +1,11 @@
 CXX = g++
-CXXFLAGS = -fopenmp -Wall -std=c++11 -O3
+KRAKEN2_SKIP_FOPENMP ?= -fopenmp
+CXXFLAGS = $(KRAKEN2_SKIP_FOPENMP) -Wall -std=c++11 -O3
 CXXFLAGS += -DLINEAR_PROBING
 
 .PHONY: all clean install
 
-PROGS = estimate_capacity build_db classify dump_table lookup_accession_numbers
+PROGS = estimate_capacity build_db classify dump_table lookup_accession_numbers k2mask
 
 all: $(PROGS)
 
@@ -30,6 +31,7 @@
 estimate_capacity.o: estimate_capacity.cc kv_store.h mmscanner.h seqreader.h utilities.h
 build_db.o: build_db.cc taxonomy.h mmscanner.h seqreader.h compact_hash.h kv_store.h kraken2_data.h utilities.h
 lookup_accession_numbers.o: lookup_accession_numbers.cc mmap_file.h utilities.h
+k2mask.o: k2mask.cc gzstream.h threadpool.h
 
 build_db: build_db.o mmap_file.o compact_hash.o taxonomy.o seqreader.o mmscanner.o omp_hack.o utilities.o
 	$(CXX) $(CXXFLAGS) -o $@ $^
@@ -45,3 +47,6 @@
 
 lookup_accession_numbers: lookup_accession_numbers.o mmap_file.o omp_hack.o utilities.o
 	$(CXX) $(CXXFLAGS) -o $@ $^
+
+k2mask: k2mask.o seqreader.o
+	$(CXX) $(CXXFLAGS) -o $@ $^ -lz -pthread

=== debian/changelog ===
kraken2 (2.1.3-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Build-Depends: zlib1g-dev
  * Depends: python3

 -- Andreas Tille <tille@debian.org>  Tue, 28 Nov 2023 20:23:52 +0100

kraken2 (2.1.2-2) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)
  * Lintian-overrides (see lintian bug #1017966)

 -- Andreas Tille <tille@debian.org>  Tue, 06 Dec 2022 17:38:23 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13),
+               zlib1g-dev
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/kraken2
 Vcs-Git: https://salsa.debian.org/med-team/kraken2.git
 Homepage: https://www.ccb.jhu.edu/software/kraken2/
@@ -14,6 +15,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
+         python3,
          ncbi-blast+
 Description: taxonomic classification system using exact k-mer matches
  Kraken 2 is the newest version of Kraken, a taxonomic classification

=== debian/watch ===
version=4

opts="uversionmangle=s/-beta/~beta/,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/DerrickWood/kraken2/tags .*/.*/v?@ANY_VERSION@@ARCHIVE_EXT@
